// douglas-peucker algorithm

void simplify(PVector[] d, float tol,int s, int e, boolean[] out) {
  out[s]=out[e]=true;
  if(abs(s-e)<=1) return;
  float distance,area, m=0.0;
  int  who=-1;
  PVector a =  d[s]; 
  PVector b = d[e]; 
  PVector c = null;
  for(int i=s+1;i<e;i++) {
    c=d[i];
    area=abs(a.x*b.y+b.x*c.y+c.x*a.y - b.x*a.y-c.x*b.y-a.x*c.y);
    distance = area/a.dist(b);
    if(distance>m && distance>tol) { 
      m=distance; 
      who=i;
    }
  }
  if(who==-1) return; 
  simplify(d,tol,s,who,out); 
  simplify(d,tol,who,e,out);
}
